/*
	This program listens on a socket for IPX broadcasts from another machine.
*/
#define NWDOS

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <fcntl.h>
#include <tiuser.h>

void main (void)
{
	IPX_ADDR	ipxAddr;
	struct t_bind tBind;
	struct t_unitdata *data;
	int fd;
	char buffer[100];
	int flags;
	int counter;
	char *ptr;
	struct netbuf *nPtr;

	fd = t_open ("/dev/nipx", O_RDWR | O_NDELAY, (struct t_info *) NULL);
	if (fd == -1)
	{
		t_error ("Open of /dev/nipx failed\n");
		return;
	}

	ipxAddr.ipxa_socket[1] = 0xA7;
	ipxAddr.ipxa_socket[0] = 0x90;
	tBind.addr.len = sizeof (ipxAddr);
	tBind.addr.maxlen = sizeof (ipxAddr);
	tBind.addr.buf = (char *) &ipxAddr;
	tBind.qlen = 5;

	if (t_bind (fd, &tBind, &tBind) == -1)
	{
		t_error ("t_bind failed\n");
		return;
	}

	data = (struct t_unitdata *) t_alloc (fd, T_UNITDATA, T_ALL);
	if (data == NULL)
	{
		t_error ("Error in t_alloc");
		return;
	}

	nPtr = & (data -> udata);
	ptr = nPtr -> buf;

	counter = 0;

	while (!kbhit())
	{
		if (t_rcvudata (fd, data, &flags))
		{
			if (t_errno == TNODATA)
			{
				if (counter > 100)
				{
					printf (".");
					counter = 0;
				}
				counter++;
			}
			else
			{
				t_error ("Error in t_rcvudata");
				printf ("Press a key to exit app...\n\n");
			}
		}
		else
		{
			printf ("\nGot data  ");
			printf ("%s %s %s %s %s\n",
				ptr,
				ptr + 3,
				ptr + 12,
				ptr + 16,
				ptr + 19);
			printf ("Press a key to exit app...\n\n");
		}
	}

	if (t_free ((char *)data, T_UNITDATA))
	{
		t_error ("Error in t_free");
	}

	if (t_unbind (fd))
	{
		t_error ("Error in t_unbind");
	}

	if (t_close (fd))
	{
		t_error ("Error in t_close");
	}

	getch ();
}